﻿function CertificateAdjuster() {
}

CertificateAdjuster.prototype.checkQuotes = function (str) {
    var result = 0, i = 0;
    for (i; i < str.length; i++)if (str[i] === '"')
        result++;
    return !(result % 2);
}

CertificateAdjuster.prototype.extract = function (from, what) {
    certName = "";

    var begin = from.indexOf(what);

    if (begin >= 0) {
        var end = from.indexOf(', ', begin);
        while (end > 0) {
            if (this.checkQuotes(from.substr(begin, end - begin)))
                break;
            end = from.indexOf(', ', end + 1);
        }
        certName = (end < 0) ? from.substr(begin) : from.substr(begin + what.length, end - begin - what.length);
    }

    return certName.replace(/^\"+|\"+$/g, '');;
}

CertificateAdjuster.prototype.Print2Digit = function (digit) {
    return (digit < 10) ? "0" + digit : digit;
}

CertificateAdjuster.prototype.GetCertDate = function (paramDate) {
    var certDate = new Date(paramDate);
    return this.Print2Digit(certDate.getUTCDate()) + "." + this.Print2Digit(certDate.getUTCMonth() + 1) + "." + certDate.getFullYear();
}

CertificateAdjuster.prototype.GetCertName = function (certSubjectName) {
    return this.extract(certSubjectName, 'CN=');
}

CertificateAdjuster.prototype.GetIssuer = function (certIssuerName) {
    return this.extract(certIssuerName, 'CN=');
}

CertificateAdjuster.prototype.Getorganization = function (certSubjectName) {
    return this.extract(certSubjectName, 'O=');
}

CertificateAdjuster.prototype.GetOGRN = function (certSubjectName) {
    return this.extract(certSubjectName, 'ОГРН=');
}

CertificateAdjuster.prototype.GetSNILS = function (certSubjectName) {
    var match = certSubjectName.match("(SNILS|СНИЛС)=([0-9]{11})");
    return match && match.length >= 3 ? match[2] : '';
}

function uuidv4() {
    return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
        var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
        return v.toString(16);
    });
}

function Base64Url(x) {
    return btoa(x).split('=')[0].replace('+', '-').replace('/', '_');
}

function hexToBase64(str) {
    return btoa(String.fromCharCode.apply(null,
        str.replace(/\r|\n/g, "").replace(/([\da-fA-F]{2}) ?/g, "0x$1 ").replace(/ +$/, "").split(" "))
    );
}

function encode_utf8(s) {
    return unescape(encodeURIComponent(s));
}

function decode_utf8(s) {
    return decodeURIComponent(escape(s));
}

function hex_to_ascii(str1) {
    var hex = str1.toString();
    var str = '';
    for (var n = 0; n < hex.length; n += 2) {
        str += String.fromCharCode(parseInt(hex.substr(n, 2), 16));
    }
    return str;
}

var CADESCOM_CADES_BES = 1;
var CADESCOM_CADES_DEFAULT = 0;
var CADESCOM_CADES_X_LONG_TYPE_1 = 93;
var CAPICOM_CURRENT_USER_STORE = 2;
var CAPICOM_MY_STORE = "My";
var CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED = 2;
var CAPICOM_CERTIFICATE_FIND_SUBJECT_NAME = 1;
var CAPICOM_ENCODE_BASE64 = 0;
var CADESCOM_HASH_ALGORITHM_CP_GOST_3411 = 100;
var CADESCOM_HASH_ALGORITHM_CP_GOST_R3411_12_256 = 101;
var CADESCOM_HASH_ALGORITHM_CP_GOST_R3411_12_512 = 102;
var CADESCOM_BASE64_TO_BINARY = 1;

function onEnterLoginClick() {
    $('#authSignature').val(null);

    $('#loginForm').submit();
}

function onEnterSignClick() {
    checkPlugInExist().then(x => {
        GetCertificates().then(
            function (certificates) {
                certificates.globalOptionList.sort(function (x, y) {
                    return (x.isValid === y.isValid) ? 0 : x.isValid ? -1 : 1;;
                });
                var certificateBlocks = certificates.globalOptionList.map(cert => {
                    var disabledClass = !cert.isValid ? 'isDisabled' : '';
                    var certDiv = $(`
                    <div class="container-fluid hoverDiv ${disabledClass}">
                        <div class="row">${cert.thumbprint}</div>
                        <div class="row header-text">С ${cert.from} по ${cert.till}</div>
                        <div class="row">
                            <div class="col-md-4">
                                <div class="header-text">Организация</div>
                                <div>${cert.organization}</div>
                            </div>
                            <div class="col-md-4">
                                <div class="header-text">Владелец</div>
                                <div>${cert.subjectName}</div>
                            </div>
                            <div class="col-md-4">
                                <div class="header-text">Выдан</div>
                                <div>${cert.issuer}</div>
                            </div>
                        </div>
                    </div>
                    <hr/>
                `);
                    certDiv.click({ subjectName: cert.subjectName, snils: cert.snils }, onCertSelected);
                    return certDiv;
                });

                $('#certificatesModalBody').html(certificateBlocks);

                $('#certificatesModal').modal('show');
            },
            function (result) {
                console.log(result);
            });
    },
        function (result) {
            var plugInNotExist = $(`
                        <div class="container-fluid">
                            <div class="header-text"><p>${result}</p></div>
                        </div>
                    `);
            document.getElementById("loginError").style.display = "none";
            $('#customLoginError').html("");
            $('#customLoginError').append(plugInNotExist);
        })
    
}   

function GetCertificates() {
    let certList = {};
    return new Promise(function (resolve, reject) {
        cadesplugin.async_spawn(function* (args) {
            showLoader();

            try {
                var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
                yield oStore.Open(CAPICOM_CURRENT_USER_STORE, CAPICOM_MY_STORE, CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);

                var CertificatesObj = yield oStore.Certificates;
                var CertificatesCount = yield CertificatesObj.Count;

                if (!Array.isArray(certList.globalOptionList)) {
                    certList.globalOptionList = [];
                }

                let dateObj = new Date();
                var Adjust = new CertificateAdjuster();
                for (let i = 1; i <= CertificatesCount; i++) {
                    var cert = yield CertificatesObj.Item(i);
                    let ValidToDate = new Date((yield cert.ValidToDate));
                    let ValidFromDate = new Date((yield cert.ValidFromDate));
                    let HasPrivateKey = yield cert.HasPrivateKey();
                    let Validator = yield cert.IsValid();
                    let IsValid = yield Validator.Result;

                    let snils = Adjust.GetSNILS(yield cert.SubjectName);
                    let formalizedSnils = snils.slice(0, 3) + "-" + snils.slice(3, 6) + "-" + snils.slice(6, 9) + " " + snils.slice(9, 11);
                   
                    certList.globalOptionList.push({
                        'subjectName': Adjust.GetCertName(yield cert.SubjectName),
                        'issuer': Adjust.GetIssuer(yield cert.IssuerName),
                        'organization': Adjust.Getorganization(yield cert.SubjectName),
                        'ogrn': Adjust.GetOGRN(yield cert.SubjectName),
                        'snils': formalizedSnils,
                        'from': Adjust.GetCertDate(yield cert.ValidFromDate),
                        'till': Adjust.GetCertDate(yield cert.ValidToDate),
                        'thumbprint': yield cert.Thumbprint,
                        'isValid': dateObj < new Date(ValidToDate) && IsValid && HasPrivateKey
                    });
                    
                }

                args[0](certList);
            }
            catch (e) {
                args[1]("Failed to get certificates. Error: " + cadesplugin.getLastError(e));
            }
            finally {
                hideLoader();
            }
        }, resolve, reject);
    });
}



function checkPlugInExist() {
    return new Promise(function (resolve, reject) {
        cadesplugin.async_spawn(function* (args) {
            var ProviderName = "Crypto-Pro GOST R 34.10-2012 Cryptographic Service Provider";
            var ProviderType = 80;
            try {
                var oAbout = yield cadesplugin.CreateObjectAsync("CAdESCOM.About");
                oVersion = yield oAbout.CSPVersion(ProviderName, parseInt(ProviderType, 10));

                var Minor = yield oVersion.MinorVersion;
                var Major = yield oVersion.MajorVersion;
                var Build = yield oVersion.BuildVersion;
                var Version = yield oVersion.toString();
                args[0]();
            }
            catch (er) {
                err = cadesplugin.getLastError(er);
                if (err.indexOf("0x80090019") + 1)
                    args[1]("Указанный CSP не установлен");
                else if (err == "Cannot read property 'CreateObjectAsync' of undefined") {
                    args[1]("Плагин не установлен");
                }
                else
                    args[1](err);

                
            }
        }, resolve, reject);
    })
}
function onCertSelected(event) {
    showLoader();

    var baseHref = document.getElementsByTagName('base')[0].href;
    $('#certificatesModal').modal('hide');
    fetch(baseHref + 'api/users' + '?snils=' + event.data.snils)
        .then((response) => {
            return response.json();
        })
        .then((users) => {
            var organizationDivs = users.map(user => {
                var orgDiv = $(`
                    <div class="container-fluid hoverDiv">
                        <div class="header-text">${user.organization.name}</div>
                    </div>
                    <hr/>
                `);
                orgDiv.click({ subjectName: event.data.subjectName, userId: user.id }, onUserSelected);
                return orgDiv;
            });
            var orgDivNotExist = $(`
                    <div class="container-fluid">
                        <div class="header-text"><p>Пользователь не найден</p></div>
                    </div>
                `);
            $("#organizationsModalBody").html("");
            $('#organizationsModalBody').append(organizationDivs);

            if (organizationDivs.length === 0) {
                $('#customLoginError').html("");
                $('#customLoginError').append(orgDivNotExist);
            }
            else if (organizationDivs.length === 1) {
                organizationDivs[0].click();
            } else {
                $('#organizationModal').modal('show');
            }
        },

        function (result) {
            console.log(result);
        })
    .finally(function () { hideLoader(); })
}

function onUserSelected(event) {
    $('#organizationModal').modal('hide');

    SignCreate(event.data.subjectName, { userId: event.data.userId }).then(
        function (jws) {
            $('#authSignature').val(jws);
            $('#authLogin').val(null);
            $('#authPassword').val(null);

            $('#loginForm').submit();
        },
        function (result) {
            console.log(result);
        });
}

function SignCreate(certSubjectName, data) {
    return new Promise(function (resolve, reject) {
        cadesplugin.async_spawn(function* (args) {
            try {
                var oStore = yield cadesplugin.CreateObjectAsync("CAdESCOM.Store");
                yield oStore.Open(CAPICOM_CURRENT_USER_STORE, CAPICOM_MY_STORE,
                    CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED);

                var CertificatesObj = yield oStore.Certificates;
                var oCertificates = yield CertificatesObj.Find(CAPICOM_CERTIFICATE_FIND_SUBJECT_NAME, certSubjectName);

                var Count = yield oCertificates.Count;
                if (Count == 0) {
                    throw ("Certificate not found: " + args[0]);
                }

                var oCertificate = yield oCertificates.Item(1);
                var oHashedData = yield cadesplugin.CreateObjectAsync("CAdESCOM.HashedData");
                var oRawSignature = yield cadesplugin.CreateObjectAsync("CAdESCOM.RawSignature");


                var payload = JSON.stringify(data);

                var enPayload = Base64Url(payload);

                let publicKey = yield oCertificate.PublicKey();
                let algorithm = yield publicKey.Algorithm;
                let algorithmValue = yield algorithm.Value;
                let alg = '';
                switch (algorithmValue) {
                    case '1.2.643.2.2.19':
                        alg = 'GOST3410-2001';
                        oHashedData.propset_Algorithm(CADESCOM_HASH_ALGORITHM_CP_GOST_3411);
                        break;
                    case '1.2.643.7.1.1.1.1':
                        alg = 'GOST3410-2012-256';
                        oHashedData.propset_Algorithm(CADESCOM_HASH_ALGORITHM_CP_GOST_R3411_12_256);
                        break;
                    case '1.2.643.7.1.1.1.2':
                        alg = 'GOST3410-2012-512';
                        oHashedData.propset_Algorithm(CADESCOM_HASH_ALGORITHM_CP_GOST_R3411_12_512);
                        break;
                }
                var header = JSON.stringify({
                    alg: alg,
                    x5c: yield oCertificate.Export(CAPICOM_ENCODE_BASE64),
                    x5t: yield oCertificate.Thumbprint
                });

                var enHeader = Base64Url(encode_utf8(header));

                var dataToSign = enHeader + '.' + enPayload;;
                oHashedData.Hash(dataToSign);
                var hexSignature = yield oRawSignature.SignHash(oHashedData, oCertificate);
                var asciiSignature = hex_to_ascii(hexSignature);
                var enSignature = Base64Url(asciiSignature);

                var jose = enHeader + '.' + enPayload + '.' + enSignature;

                yield oStore.Close();

                args[2](jose);
            }
            catch (e) {
                args[3]("Failed to create signature. Error: " + cadesplugin.getLastError(e));
            }
        }, certSubjectName, data, resolve, reject);
    });
}

function showLoader() {
    document.getElementById("loader").style.display = "block";
    $('#mainpage').addClass('loading');
}

function hideLoader() {
    $('#mainpage').removeClass('loading');
    document.getElementById("loader").style.display = "none";
}

if ($('#enterLogin').length) {
    document.getElementById("enterLogin").addEventListener("click", onEnterLoginClick);
}
else {
    document.getElementById("enterSign").style.display = "block";
    document.getElementById("enterSign").style.marginLeft = "auto";
    document.getElementById("enterSign").style.marginRight = "auto";
    document.getElementById("enterSign").style.float = "none";
}

if ($('#enterSign').length) {
    document.getElementById("enterSign").addEventListener("click", onEnterSignClick);
}


$('#organizationModal').on('shown.bs.modal', function () {
    $('#organizationModal').trigger('focus')
})

$('#certificatesModal').on('shown.bs.modal', function () {
    $('#certificatesModal').trigger('focus')
})